import re

from pathlib import Path
from urllib.parse import urljoin

from django.db import models
from django.urls import reverse
from django.template import loader

import settings
from troggle.core.models.troggle import Expedition, TroggleModel

"""The model declarations  LogBookEntry, PersonLogEntry, QM
"""

todo = """
- Can we rewrite things to eliminate the CaveSlug and objects? No
  Surely foreign keys work fine ?! No
  
  Foreign keys do not allow for there being multiple ways to refer to a cave, eg 1623-1999-03 aka 1623-204
  Having slugs allows for much more loose coupling to caves, which removes alot of the need to reset the database, which interupts work flow.
  It also means we do not have to be creating temporary cave objects in the database, where we do not have the underlying file in cave_data.

  To Do move Cave Slug back to troggle.core.models
	
"""


class CaveSlug(models.Model):
    """Moved here to avoid nasty cyclic import error
    CASCADE means that if the Cave is deleted, this is too
    """

    cave = models.ForeignKey("Cave", on_delete=models.CASCADE)
    slug = models.SlugField(max_length=50, unique=True)
    primary = models.BooleanField(default=False)

    def __str__(self):
        return f"{self.slug}: {self.cave}"


class LogbookEntry(TroggleModel):
    """Single parsed entry from Logbook
    Gets deleted if the Expedition gets deleted"""

    date = (
        models.DateField()
    ) 
    expedition = models.ForeignKey(Expedition, blank=True, null=True, on_delete=models.CASCADE)  
    title = models.CharField(max_length=200)
    cave_slug = models.SlugField(max_length=50, blank=True, null=True)
    place = models.CharField(
        max_length=100, blank=True, null=True, help_text="Only use this if you haven't chosen a cave"
    )
    other_people = models.CharField(max_length=200, blank=True, null=True) # foreign_friends and *guests
    text = models.TextField()
    slug = models.SlugField(max_length=50) # this is tripid 
    time_underground = models.FloatField(null=True, help_text="In decimal hours")

    class Meta:
        verbose_name_plural = "Logbook Entries"
        # several PersonLogEntrys point in to this object
        ordering = ("-date",)

    def cave(self):  # Why didn't he just make this a foreign key to Cave ?
        c = CaveSlug.objects.get(slug=self.cave_slug, primary=True).cave
        return c

    def isLogbookEntry(self):  # Function used in templates
        return True

    def get_absolute_url(self):
        # we do not use URL_ROOT any more.
        return reverse("logbookentry", kwargs={"date": self.date, "slug": self.slug})

    def __str__(self):
        return f"{self.date}: {self.title}"

    def get_next_by_id(self):
        LogbookEntry.objects.get(id=self.id + 1)

    def get_previous_by_id(self):
        LogbookEntry.objects.get(id=self.id - 1)

    def DayIndex(self):
        """This is used to set different colours for the different trips on
        the calendar view of the expedition"""
        mx = 10
        todays = list(LogbookEntry.objects.filter(date=self.date))
        if self in todays:
            index = todays.index(self)
        else:
            print(f"DayIndex: Synchronization error in logbook entries. Restart server or do full reset.  {self}")
            index = 0

        if index not in range(0, mx):
            print(f"DayIndex: More than {mx-1} LogbookEntry items on one day  '{index}' {self}, restarting colour sequence.")
            index = index % mx
        return index

def writelogbook(year, filename):
    current_expedition = Expedition.objects.get(year=year)
    logbook_entries = LogbookEntry.objects.filter(expedition=current_expedition).order_by(
        "slug"
    )  # now that slug, aka tripid, is in our standard date form, this will preserve ordering.

    print(f"  - Logbook to be exported has {len(logbook_entries)} entries in it.")

    template = "logbook2005style.html"
    
    try:
        t = loader.get_template(template)
        logbookfile = t.render({"logbook_entries": logbook_entries})
    except:
        print("   ! Very Bad Error RENDERING template " + template)
        raise
    # print("  - template rendered")
    try:
        try:
            endpath = Path(settings.EXPOWEB, "years", str(year), "endmatter.html")
        except:
            print("   ! FAIL Path " + {(settings.EXPOWEB, "years", year, "endmatter.html")})
            raise
        # print(f"  - endpath {endpath}")
        endmatter = ""
        if endpath.is_file():
            # print("  - endpath")
            try:
                with open(endpath, "r") as end:
                    endmatter = end.read()
            except:
                print("   ! Very Bad Error opening " + endpath)
                raise
    except:
        print("   ! FAIL endpath " + endpath)
        raise
    # print("  - endpath opened")

    frontpath = Path(settings.EXPOWEB, "years", str(year), "frontmatter.html")
    if frontpath.is_file():
        try:
            with open(frontpath, "r") as front:
                frontmatter = front.read()
        except:
            print("   ! Very Bad Error opening " + frontpath)
        logbookfile = re.sub(r"<body>", "<body>\n" + frontmatter + endmatter, logbookfile)
    else:
        logbookfile = re.sub(r"<body>", f"<body>\n<h1>Expo {year}</h1>\n" + endmatter, logbookfile)

    dir = Path(settings.EXPOWEB) / "years" / str(year)
    filepath = Path(dir, filename)
    try:
        with (open(filepath, "w")) as lb:
            lb.writelines(logbookfile)
    except:
        print("   ! Very Bad Error writing to  " + filepath)
        raise

    # print(f'Logbook exported to {filepath}')
    
class PersonLogEntry(TroggleModel):
    """Single Person going on a trip, which may or may not be written up.
    It could account for different T/U for people in same logbook entry.
    
    CASCADE means that if the personexpedition or the logbookentry is deleted,
    then this PersonLogEntry is deleted too
    """

    personexpedition = models.ForeignKey("PersonExpedition", null=True, on_delete=models.CASCADE)
    time_underground = models.FloatField(help_text="In decimal hours")
    logbook_entry = models.ForeignKey(LogbookEntry, on_delete=models.CASCADE)
    is_logbook_entry_author = models.BooleanField(default=False)
    nickname_used = models.CharField(max_length=100,default="") # e.g. "Animal" or "Zonker", as it appears in the original logbook

    class Meta:
        ordering = ("-personexpedition",)
        # order_with_respect_to = 'personexpedition'

    def next_personlog(self):
        futurePTs = (
            PersonLogEntry.objects.filter(
                personexpedition=self.personexpedition, logbook_entry__date__gt=self.logbook_entry.date
            )
            .order_by("logbook_entry__date")
            .all()
        )
        if len(futurePTs) > 0:
            return futurePTs[0]
        else:
            return None

    def prev_personlog(self):
        pastPTs = (
            PersonLogEntry.objects.filter(
                personexpedition=self.personexpedition, logbook_entry__date__lt=self.logbook_entry.date
            )
            .order_by("-logbook_entry__date")
            .all()
        )
        if len(pastPTs) > 0:
            return pastPTs[0]
        else:
            return None

    def place(self):
        return self.logbook_entry.cave and self.logbook_entry.cave or self.logbook_entry.place

    def __str__(self):
        return f"{self.personexpedition} ({self.logbook_entry.date})"


class QM(TroggleModel):
    """This is based on qm.csv in trunk/expoweb/1623/204 which has the fields:
    "Number","Grade","Area","Description","Page reference","Nearest station","Completion description","Comment"
    
    All the stuff handling TICK QMs is INCOMPLETE
    """

    number = models.IntegerField(
        help_text="this is the sequential number in the year, only unique for CSV imports",
    )
    grade = models.CharField(max_length=1, blank=True, null=True, help_text="A/B/C/D/X")
    cave = models.ForeignKey("Cave", related_name="QMs", blank=True, null=True, on_delete=models.SET_NULL)
    block = models.ForeignKey("SurvexBlock", null=True, on_delete=models.SET_NULL)  # only for QMs from survex files
    blockname = models.TextField(blank=True, null=True)  # NB truncated copy of survexblock name with last char added
    expoyear = models.CharField(max_length=4, blank=True, null=True)  
    ticked = models.BooleanField(default=False)  
    location_description = models.TextField(blank=True, null=True)
    completion_description = models.TextField(blank=True, null=True)
    completion_date = models.DateField(blank=True, null=True)
    nearest_station_name    = models.CharField(max_length=200, blank=True, null=True)
    resolution_station_name = models.CharField(max_length=200, blank=True, null=True)
    area = models.CharField(max_length=100, blank=True, null=True)
    page_ref = models.TextField(blank=True, null=True)
    comment = models.TextField(blank=True, null=True)

    def __str__(self):
        return f"{self.code()}"

    def code(self):
        if self.cave:
            cavestr = str(self.cave.slug())[5:]
        else:
            cavestr = ""
        if self.expoyear:
            expoyearstr = str(self.expoyear)
        else:
            expoyearstr = str(self.cave.slug())[5:9]
        if self.blockname:
            blocknamestr = "-" + str(self.blockname)
        else:
            blocknamestr = ""
        return f"{cavestr}-{expoyearstr}-{self.number}{self.grade}{blocknamestr}"


    def newslug(self):
        qmslug = f"{str(self.cave)}-{self.expoyear}-{self.blockname}{self.number}{self.grade}"
        return qmslug

    def get_absolute_url(self):
        # This reverse resolution stuff is pure magic. Just change the regex in urls.py and everything changes to suit. Whacky.
        return urljoin(
            settings.URL_ROOT,
            reverse(
                "qm",
                kwargs={
                    "cave_id": self.cave.slug(),
                    "year": self.expoyear,
                    "blockname": self.blockname,
                    "qm_id": self.number,
                    "grade": self.grade,
                },
            ),
        )

    def get_next_by_id(self): # called in template
        return QM.objects.get(id=self.id + 1)

    def get_previous_by_id(self):  # called in template
        return QM.objects.get(id=self.id - 1)
